module Main where

main :: IO ()
main = do
  raw <- getContents
  let ls = map read $ lines raw :: [Int]
    in do
      putStrLn $ "day1a: " ++ (show (solveA ls))
      putStrLn $ "day1b: " ++ (show (solveB ls))

numIncreasing :: [Int] -> Int
numIncreasing [] = 0
numIncreasing xs =
  length . (filter id) $ zipWith (<) xs (tail xs)

plus3 :: Int -> Int -> Int -> Int
plus3 x y z = x + y + z

solveA :: [Int] -> Int
solveA = numIncreasing

solveB :: [Int] -> Int
solveB xs
  | length xs < 3 = 0
  | otherwise = numIncreasing zs
  where
    zs = zipWith3 plus3 xs (tail xs) (drop 2 xs)
