module Main where

data Com =
    Forward Int
  | Down Int
  | Up Int

--             Hor Dep Aim
data Pos = Pos Int Int Int

toCommand :: [String] -> Com
toCommand xs
  | length xs /= 2 = error "malformed input"
  | otherwise = case (head xs) of
      "forward" -> Forward $ read (xs !! 1)
      "up" -> Up $ read (xs !! 1)
      "down" -> Down $ read (xs !! 1)

main :: IO ()
main = do
  raw <- getContents
  let ls = map (toCommand . words) $ lines raw
    in do
      putStrLn $ "day2a: " ++ (show (solveA ls))
      putStrLn $ "day2b: " ++ (show (solveB ls))

foldComs :: Pos -> Com -> Pos
foldComs (Pos h d a) (Forward x) = Pos (h+x) d a
foldComs (Pos h d a) (Down y) = Pos h (d+y) a
foldComs (Pos h d a) (Up y) = Pos h (d-y) a

foldComs' :: Pos -> Com -> Pos
foldComs' (Pos h d a) (Forward x) = Pos (h+x) (d+(a*x)) a
foldComs' (Pos h d a) (Down y) = Pos h d (a+y)
foldComs' (Pos h d a) (Up y) = Pos h d (a-y)

mult :: Pos -> Int
mult (Pos h d a) = h * d

solveA :: [Com] -> Int
solveA = mult . (foldl foldComs (Pos 0 0 0))

solveB :: [Com] -> Int
solveB = mult . (foldl foldComs' (Pos 0 0 0))
