module Main where

import Data.List

main :: IO ()
main = do
  raw <- getLine
  let input = sort $ map read $ words $ repCom raw
  putStrLn $ "day7a: " ++ (show $ solveA input)
  putStrLn $ "day7b: " ++ (show $ solveB input)

solveA :: [Int] -> Int
solveA is = sum $ map (absdiff mid) is
  where
    mid = is !! (length is `div` 2)

solveB :: [Int] -> Int
solveB is = sum $ map (expdiff mid) is
  where
    mid = (sum is) `div` (length is)

absdiff :: Int -> Int -> Int
absdiff x y = abs (x - y)

expdiff :: Int -> Int -> Int
expdiff x y = sum $ take (absdiff x y) [1..]

repCom :: String -> String
repCom = map f
  where f c = if c == ',' then ' ' else c

