-- ==== A HAIKU ====
--   the eternal lie
--   all programmers say
--   "i will clean this up"

module Main where

import Data.Char
import Data.List
import Debug.Trace

main :: IO ()
main = do
  raw <- getContents
  let input = lines raw
    in do
      putStrLn $ "day8a: " ++ (show $ solveA input)
      putStrLn $ "day8b: " ++ (show $ sum $ map solveB input)

solveA :: [String] -> Int
solveA ss = length $ filter f $ concat $ map ((drop 11) . words) ss
  where
    f s = (length s) `elem` [2,4,3,7]

toNum :: [Int] -> Int
toNum is = f 0 $ reverse is
  where f _ [] = 0
        f x (a:as) = (10^x)*a + (f (x+1) as)

solveB :: String -> Int
solveB is =
  toNum $ map (toSegments . sort . (decode key) . sort) (drop 11 js)
  where
    js = words is
    ms = sortBy (\x y -> compare (length (filter id x)) (length (filter id y))) (map toArray $ take 10 js)
    (a:b:c:d:e:f:g:h:i:j:_) = ms
    key = map fromArray $
            final $
            handleTwo a $
            handleThree b $
            handleFour c $
            handleFive d e f $
            handleSix g h i $
            handleSeven j $
            initGuess

merge :: [[Bool]] -> [[Bool]] -> [[Bool]]
merge = zipWith mergeCol

mergeCol :: [Bool] -> [Bool] -> [Bool]
mergeCol = zipWith (&&)

myUnion :: [Bool] -> [Bool] -> [Bool]
myUnion = zipWith (||)

xor :: Bool -> Bool -> Bool
xor a b = (a || b) && not (a && b)

mergeXor :: [Bool] -> [Bool] -> [Bool]
mergeXor = zipWith xor

nil :: [Bool]
nil = take 7 $ repeat False

unnil :: [Bool]
unnil = take 7 $ repeat True

onThree :: ([a] -> [a] -> [a]) -> [a] -> [a] -> [a] -> [a]
onThree f a b c = f a (f b c)

handleTwo :: [Bool] -> [[Bool]] -> [[Bool]]
handleTwo one acc = merge acc s
  where
    s = [unnil, unnil, one, unnil, unnil, one, unnil]

handleFour :: [Bool] -> [[Bool]] -> [[Bool]]
handleFour four acc = merge acc s
  where
    s = [unnil, four, four, four, unnil, four, unnil]

handleThree :: [Bool] -> [[Bool]] -> [[Bool]]
handleThree seven acc = merge acc s
  where
    s = [seven, unnil, seven, unnil, unnil, seven, unnil]

handleSeven :: [Bool] -> [[Bool]] -> [[Bool]]
handleSeven = seq

handleFive :: [Bool] -> [Bool] -> [Bool] -> [[Bool]] -> [[Bool]]
handleFive a b c acc = (onThree merge) v u $ (onThree merge) t s acc
  where
    s = [three, unnil, three, three, unnil, three, three]
    -- s = take 7 $ repeat unnil
    -- v = take 7 $ repeat unnil
    t = take 7 $ repeat unnil
    -- t = [unnil, be, unnil, unnil, be, unnil, unnil]
    u = [adg, unnil, unnil, adg, unnil, unnil, adg]
    v = [unnil, unnil, cf, unnil, unnil, cf, unnil]
    be = map not $ (onThree mergeXor) a b c
    adg = (onThree mergeCol) a b c
    cf = map not $ (onThree mergeCol) adg be unnil
    three =
      if (myUnion a b) == unnil
      then c
      else if (myUnion b c) == unnil
      then a
      else b

handleSix :: [Bool] -> [Bool] -> [Bool] -> [[Bool]] -> [[Bool]]
handleSix a b c acc = (onThree merge) s t acc
  where
    s = [abfg, abfg, unnil, unnil, unnil, abfg, abfg]
    t = [unnil, unnil, cde, cde, cde, unnil, unnil]
    abfg = (onThree mergeCol) a b c
    cde = map not $ abfg

final :: [[Bool]] -> [[Bool]]
final gs = map h gs
  where
    h g = if isSingle g then g else mergeCol g singles
    singles = map not $ foldr myUnion nil $ map f gs
    f g = if isSingle g then g else nil
    isSingle g = length (filter id g) == 1

toArray :: String -> [Bool]
toArray s = g $ map f s
  where
    f c = (ord c) - (ord 'a')
    g is = [
        (0 `elem` is)
      , (1 `elem` is)
      , (2 `elem` is)
      , (3 `elem` is)
      , (4 `elem` is)
      , (5 `elem` is)
      , (6 `elem` is)
      ]

initGuess :: [[Bool]]
initGuess = take 7 $ repeat unnil

fromArray :: [Bool] -> Char
fromArray x = f 0 x
  where
    f _ [] = error "no answer"
    f x (True:_) = (chr $ (ord 'a') + x)
    f x (False:xs) = f (x+1) xs

p :: [[Bool]] -> IO ()
p gs = mapM_ putStrLn $ map (\r -> map (\c -> if c then 'X' else '.') r) gs

decode :: String -> String -> String
decode s c = map (\n -> f n s 0) c
  where
    f _ [] _ = error "out of key"
    f x (a:as) n = if x == a then (chr (n+(ord 'a'))) else f x as (n+1)

toSegments :: String -> Int
toSegments s = case sort s of
  "abcefg" -> 0
  "cf" -> 1
  "acdeg" -> 2
  "acdfg" -> 3
  "bcdf" -> 4
  "abdfg" -> 5
  "abdefg" -> 6
  "acf" -> 7
  "abcdefg" -> 8
  "abcdfg" -> 9
  _ -> error "not a number"
