{
  description = "Thorn's Haskell Repo";
  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };
  outputs = { self, ... }@inputs:
  inputs.flake-utils.lib.eachSystem
    [ "x86_64-linux" ]
    (system:
      let pkgs = import inputs.nixpkgs {
        overlays = [ ((import ./nix/overlay.nix) inputs) ];
        inherit system;
      };
      in rec {
        defaultPackage = packages.aoc2021;
        packages = (inputs.flake-utils.lib.flattenTree
          ((import ./nix/utils.nix) { inherit pkgs; inherit inputs; }))
          // { aoc2021 = pkgs.aoc2021; };
        hydraJobs = builtins.listToAttrs
        (map (s: { name = s; value = {
            ${system} = packages.${s};
          }; })
          (builtins.attrNames packages));
      }) // {
        overlay = (import ./nix/overlay.nix) inputs;
      };
}
